/***************************************************************************
                          mpeg_es.h  -  description
                             -------------------
   Functions for handling mpeg elementary streams.
                             -------------------
    begin                : Fri Feb 4 2005
    copyright            : (C) 2005 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _MPEG_ES_H_
#define _MPEG_ES_H_

#include "common/typedefs.h"
#include "common/File.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Plays the elementary stream contained in the given file.
      INPUT: fp          - Points to the FILE with the elementary stream.
             stream_type - See PMT_SECTION.h for STREAM_TYPE_* values.
      RETURN: Success - A non-zero value
              Failure - 0 */
int MPEG_ES_Play(FILE_PTR fp, u8 stream_type);

/* Finds the module that can play the type of stream given
      INPUT: stream_type - See PMT_SECTION.h for STREAM_TYPE_* values.
      RETURN: Success - The location of the module in the global
                          struct (sys.psi_pes[]).
              Failure - A negative value. */
int MPEG_ES_find_module(u8 stream_type);

#ifdef __cplusplus
};
#endif

#endif

