/***************************************************************************
                       output_blocks.h  -  description
                             -------------------
   Functions used for placing decoded blocks into the frame buffer.
                             -------------------
    begin                : Tue Dec 14 2004
    copyright            : (C) 2004 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __OUTPUT_BLOCKS_H__
#define __OUTPUT_BLOCKS_H__

#include "common/typedefs.h"
#include "SLICE.h"


#ifdef __cplusplus
extern "C" {
#endif

/* Place a decoded Block into the frame buffer.
      INPUT: slice - Points to the SLICE holding the decoded Block,
                       and the pointer to the frame buffer. */
void output_block(SLICE *slice);

/* Place skipped Macro-Blocks into the frame buffer.
      INPUT: slice - Points to the SLICE holding the pointer to the
                       frame buffer.
             cnt   - Number of Macro-Blocks that were skipped. */
void skip_macroblocks(SLICE *slice, u32 cnt);

#ifdef __cplusplus
};
#endif

#endif
