/***************************************************************************
                       I_MACROBLOCK.h  -  description
                             -------------------
   Stuff needed for handling I picture macroblocks.
                             -------------------
    begin                : Mon Jun 26 2006
    copyright            : (C) 2006 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __I_MACROBLOCK_H__
#define __I_MACROBLOCK_H__

#include "common/typedefs.h"
#include "SEQ_LAYER.h"
#include "PIC_LAYER.h"

/*
# ifndef OUTPUT_BLOCK_TRACE
#  define OUTPUT_BLOCK_TRACE 1
# endif
*/

#ifdef __cplusplus
extern "C" {
#endif

/* Read the I picture macroblock data.
      INPUT: seq - Pointer to a SEQ_LAYER structure.
             pic - Pointer to a PIC_LAYER structure. */
void VC1_VIDEO_read_I_MACROBLOCK(SEQ_LAYER *seq, PIC_LAYER *pic);

/* Process an intra block.
      INPUT: seq - Pointer to a SEQ_LAYER structure.
             pic - Pointer to a PIC_LAYER structure. */
void VC1_VIDEO_end_I_BLOCK(SEQ_LAYER *seq, PIC_LAYER *pic);


/* Calculate the CBP value */
#define VC1_VIDEO_get_CBP(Y, L, LT, T, tmp) \
   tmp = (T & 0x20) - (LT & 0x10); \
   if ( ( (tmp <= 0x10)&&(L & 0x40) )||   /* (T2 == LT3)&&(L1) */ \
        (tmp == 0x20) )                   /* (T2 != LT3)&&(T2) */ \
      Y ^= 0x80; \
   tmp = (T & 0x20) - (T & 0x10); \
   if ( ( (tmp <= 0x10)&&(Y & 0x80) )||   /* (T2 == T3)&&(Y0) */ \
        (tmp == 0xF0) )                   /* (T2 != T3)&&(T3) */ \
      Y ^= 0x40; \
   tmp = (Y & 0x80) - (L & 0x40); \
   if ( ( (tmp <= 0x40)&&(L & 0x10) )||   /* (Y0 == L1)&&(L3) */ \
        (tmp == 0x80) )                   /* (Y0 != L1)&&(Y0) */ \
      Y ^= 0x20; \
   tmp = (Y & 0x80) - (Y & 0x40); \
   if ( ( (tmp <= 0x40)&&(Y & 0x20) )||   /* (Y0 == Y1)&&(Y2) */ \
        (tmp == 0xC0) )                   /* (Y0 != Y1)&&(Y1) */ \
      Y ^= 0x10

#ifdef __cplusplus
};
#endif

#endif

