/***************************************************************************
                       P_MACROBLOCK.h  -  description
                             -------------------
   Stuff needed for handling P picture macroblocks.
                             -------------------
    begin                : Mon Oct 30 2006
    copyright            : (C) 2006 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __P_MACROBLOCK_H__
#define __P_MACROBLOCK_H__

#include "common/typedefs.h"
#include "SEQ_LAYER.h"
#include "PIC_LAYER.h"

/*
# ifndef OUTPUT_BLOCK_TRACE
#  define OUTPUT_BLOCK_TRACE 1
# endif
*/

#ifdef __cplusplus
extern "C" {
#endif

/* Read the P picture macroblock data.
      INPUT: seq - Pointer to a SEQ_LAYER structure.
             pic - Pointer to a PIC_LAYER structure. */
void VC1_VIDEO_read_P_MACROBLOCK(SEQ_LAYER *seq, PIC_LAYER *pic);

/* Process an inter block.
      INPUT: seq - Pointer to a SEQ_LAYER structure.
             pic - Pointer to a PIC_LAYER structure. */
void VC1_VIDEO_end_BLOCK(SEQ_LAYER *seq, PIC_LAYER *pic);

/* Scale the given 'coeff' to the new step size */
s32 VC1_SCALE_COEFF(s32 coeff, s32 step_old, s32 step_new);

#ifdef __cplusplus
};
#endif

#endif

