/***************************************************************************
                          tables.c  -  description
                             -------------------
    begin                : Thu Jun 29 2006
    copyright            : (C) 2006 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "common/typedefs.h"


const u8 VC1_MV_SIZE_TAB[]   = {2-1, 3-1, 4-1, 5-1, 8-1},
         VC1_MV_OFFSET_TAB[] = {1,   3,   7,  15,  31};

static const u8 VC1_LUMA_RUN_LEVEL0_TAB[] =
{
  119,   /* StartIndexOfLast */
  138-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
  169-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  207-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  226-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  232,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  0, 13,  0, 14,  0, 15,  0, 16,
    0, 17,  0, 18,  0, 19,  1,  1,  1,  2,  1,  3,  1,  4,  1,  5,
    1,  6,  1,  7,  1,  8,  1,  9,  1, 10,  1, 11,  1, 12,  1, 13,
    1, 14,  1, 15,  2,  1,  2,  2,  2,  3,  2,  4,  2,  5,  2,  6,
    2,  7,  2,  8,  2,  9,  2, 10,  2, 11,  2, 12,  3,  1,  3,  2,
    3,  3,  3,  4,  3,  5,  3,  6,  3,  7,  3,  8,  3,  9,  3, 10,
    3, 11,  4,  1,  4,  2,  4,  3,  4,  4,  4,  5,  4,  6,  5,  1,
    5,  2,  5,  3,  5,  4,  5,  5,  6,  1,  6,  2,  6,  3,  6,  4,
    7,  1,  7,  2,  7,  3,  7,  4,  8,  1,  8,  2,  8,  3,  8,  4,
    9,  1,  9,  2,  9,  3,  9,  4, 10,  1, 10,  2, 10,  3, 11,  1,
   11,  2, 11,  3, 12,  1, 12,  2, 12,  3, 13,  1, 13,  2, 13,  3,
   14,  1, 14,  2, 14,  3, 15,  1, 15,  2, 15,  3, 16,  1, 16,  2,
   17,  1, 17,  2, 18,  1, 19,  1, 20,  1, 21,  1, 22,  1, 23,  1,
   24,  1, 25,  1, 26,  1, 27,  1, 28,  1, 29,  1, 30,  1,

    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  1,  1,  1,  2,
    1,  3,  1,  4,  1,  5,  2,  1,  2,  2,  2,  3,  2,  4,  3,  1,
    3,  2,  3,  3,  3,  4,  4,  1,  4,  2,  4,  3,  5,  1,  5,  2,
    6,  1,  6,  2,  7,  1,  7,  2,  8,  1,  8,  2,  9,  1,  9,  2,
   10,  1, 10,  2, 11,  1, 11,  2, 12,  1, 12,  2, 13,  1, 13,  2,
   14,  1, 14,  2, 15,  1, 15,  2, 16,  1, 17,  1, 18,  1, 19,  1,
   20,  1, 21,  1, 22,  1, 23,  1, 24,  1, 25,  1, 26,  1, 27,  1,
   28,  1, 29,  1, 30,  1, 31,  1, 32,  1, 33,  1, 34,  1, 35,  1,
   36,  1, 37,  1,

/* delta level values */
   19, 15, 12, 11,  6,  5,  4,  4,  4,  4,  3,  3,  3,  3,  3,  3,
    2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,

    6,  5,  4,  4,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
    1,  1,  1,  1,  1,  1,

/* delta run values */
   30+1, 17+1, 15+1,  9+1,  5+1,  4+1,  3+1,  3+1,  3+1,  3+1,  3+1,
    2+1,  1+1,  1+1,  1+1,  0+1,  0+1,  0+1,  0+1,

   37+1, 15+1,  4+1,  3+1,  1+1,  0+1
},

                VC1_LUMA_RUN_LEVEL1_TAB[] =
{
   67,   /* StartIndexOfLast */
   76-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
   91-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  112-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  139-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  147,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  0, 13,  0, 14,  0, 15,  0, 16,
    0, 17,  0, 18,  0, 19,  0, 20,  0, 21,  0, 22,  0, 23,  0, 24,
    0, 25,  0, 26,  0, 27,  1,  1,  1,  2,  1,  3,  1,  4,  1,  5,
    1,  6,  1,  7,  1,  8,  1,  9,  1, 10,  2,  1,  2,  2,  2,  3,
    2,  4,  2,  5,  3,  1,  3,  2,  3,  3,  3,  4,  4,  1,  4,  2,
    4,  3,  5,  1,  5,  2,  5,  3,  6,  1,  6,  2,  6,  3,  7,  1,
    7,  2,  7,  3,  8,  1,  8,  2,  9,  1,  9,  2, 10,  1, 11,  1,
   12,  1, 13,  1, 14,  1,

    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    1,  1,  1,  2,  1,  3,  2,  1,  2,  2,  3,  1,  3,  2,  4,  1,
    4,  2,  5,  1,  5,  2,  6,  1,  6,  2,  7,  1,  8,  1,  9,  1,
   10,  1, 11,  1, 12,  1, 13,  1, 14,  1, 15,  1, 16,  1, 17,  1,
   18,  1, 19,  1, 20,  1,

/* delta level values */
   27, 10,  5,  4,  3,  3,  3,  3,  2,  2,  1,  1,  1,  1,  1,

    8,  3,  2,  2,  2,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,
    1,  1,  1,  1,  1,  1,

/* delta run values */
   14+1,  9+1,  7+1,  3+1,  2+1,  1+1,  1+1,  1+1,  1+1,  1+1,  0+1,
    0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,
    0+1,  0+1,  0+1,  0+1,  0+1,

   20+1,  6+1,  1+1,  0+1,  0+1,  0+1,  0+1,  0+1
},

                VC1_LUMA_RUN_LEVEL2_TAB[] =
{
  126,   /* StartIndexOfLast */
   78-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
   93-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  110-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  166-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  170,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  0, 13,  0, 14,  0, 15,  0, 16,
    0, 17,  0, 18,  0, 19,  0, 20,  0, 21,  0, 22,  0, 23,  0, 24,
    0, 25,  0, 26,  0, 27,  0, 28,  0, 29,  0, 30,  0, 31,  0, 32,
    0, 33,  0, 34,  0, 35,  0, 36,  0, 37,  0, 38,  0, 39,  0, 40,
    0, 41,  0, 42,  0, 43,  0, 44,  0, 45,  0, 46,  0, 47,  0, 48,
    0, 49,  0, 50,  0, 51,  0, 52,  0, 53,  0, 54,  0, 55,  0, 56,
    1,  1,  1,  2,  1,  3,  1,  4,  1,  5,  1,  6,  1,  7,  1,  8,
    1,  9,  1, 10,  1, 11,  1, 12,  1, 13,  1, 14,  1, 15,  1, 16,
    1, 17,  1, 18,  1, 19,  1, 20,  2,  1,  2,  2,  2,  3,  2,  4,
    2,  5,  2,  6,  2,  7,  2,  8,  2,  9,  2, 10,  3,  1,  3,  2,
    3,  3,  3,  4,  3,  5,  3,  6,  3,  7,  4,  1,  4,  2,  4,  3,
    4,  4,  4,  5,  4,  6,  5,  1,  5,  2,  5,  3,  5,  4,  5,  5,
    6,  1,  6,  2,  6,  3,  6,  4,  7,  1,  7,  2,  7,  3,  8,  1,
    8,  2,  8,  3,  9,  1,  9,  2,  9,  3, 10,  1, 10,  2, 11,  1,
   11,  2, 12,  1, 12,  2, 13,  1, 13,  2, 14,  1,

    0,  1,  0,  2,  0,  3,  0,  4,  1,  1,  1,  2,  1,  3,  2,  1,
    2,  2,  2,  3,  3,  1,  3,  2,  4,  1,  4,  2,  5,  1,  5,  2,
    6,  1,  6,  2,  7,  1,  7,  2,  8,  1,  8,  2,  9,  1,  9,  2,
   10,  1, 10,  2, 11,  1, 11,  2, 12,  1, 12,  2, 13,  1, 13,  2,
   14,  1, 14,  2, 15,  1, 16,  1,

/* delta level values */
   56, 20, 10,  7,  6,  5,  4,  3,  3,  3,  2,  2,  2,  2,  1,

    4,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  1,  1,

/* delta run values */
   14+1, 13+1,  9+1,  6+1,  5+1,  4+1,  3+1,  2+1,  2+1,  2+1,  1+1,  
    1+1,  1+1,  1+1,  1+1,  1+1,  1+1,  1+1,  1+1,  1+1,  0+1,  0+1,
    0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,
    0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,
    0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,
    0+1,

   16+1, 14+1,  2+1,  0+1
},

                VC1_LUMA_RUN_LEVEL3_TAB[] =
{
   85,   /* StartIndexOfLast */
  100-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
  121-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  148-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  164-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  168,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  0, 13,  0, 14,  0, 15,  0, 16,
    1,  1,  1,  2,  1,  3,  1,  4,  1,  5,  1,  6,  1,  7,  1,  8,
    1,  9,  1, 10,  1, 11,  2,  1,  2,  2,  2,  3,  2,  4,  2,  5,
    2,  6,  2,  7,  2,  8,  3,  1,  3,  2,  3,  3,  3,  4,  3,  5,
    3,  6,  3,  7,  4,  1,  4,  2,  4,  3,  4,  4,  4,  5,  5,  1,
    5,  2,  5,  3,  5,  4,  6,  1,  6,  2,  6,  3,  6,  4,  7,  1,
    7,  2,  7,  3,  8,  1,  8,  2,  8,  3,  9,  1,  9,  2,  9,  3,
   10,  1, 10,  2, 10,  3, 11,  1, 11,  2, 11,  3, 12,  1, 12,  2,
   12,  3, 13,  1, 13,  2, 13,  3, 14,  1, 14,  2, 15,  1, 15,  2,
   16,  1, 17,  1, 18,  1, 19,  1, 20,  1,

    0,  1,  0,  2,  0,  3,  0,  4,  1,  1,  1,  2,  1,  3,  1,  4,
    2,  1,  2,  2,  2,  3,  3,  1,  3,  2,  3,  3,  4,  1,  4,  2,
    5,  1,  5,  2,  6,  1,  6,  2,  7,  1,  7,  2,  8,  1,  8,  2,
    9,  1,  9,  2, 10,  1, 10,  2, 11,  1, 11,  2, 12,  1, 12,  2,
   13,  1, 13,  2, 14,  1, 15,  1, 16,  1, 17,  1, 18,  1, 19,  1,
   20,  1, 21,  1, 22,  1, 23,  1, 24,  1, 25,  1, 26,  1,

/* delta level values */
   16, 11,  8,  7,  5,  4,  4,  3,  3,  3,  3,  3,  3,  3,  2,  2,
    1,  1,  1,  1,  1,

    4,  4,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  1,  1,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,

/* delta run values */
   20+1, 15+1, 13+1,  6+1,  4+1,  3+1,  3+1,  2+1,  1+1,  1+1,  1+1,
    0+1,  0+1,  0+1,  0+1,  0+1,

   26+1, 13+1,  3+1,  1+1
},

                VC1_CHROMA_RUN_LEVEL0_TAB[] =
{
   99,   /* StartIndexOfLast */
  144-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
  171-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  208-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  231-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  240,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  0, 13,  0, 14,  0, 15,  0, 16,
    0, 17,  0, 18,  0, 19,  0, 20,  0, 21,  0, 22,  0, 23,  1,  1,
    1,  2,  1,  3,  1,  4,  1,  5,  1,  6,  1,  7,  1,  8,  1,  9,
    1, 10,  1, 11,  2,  1,  2,  2,  2,  3,  2,  4,  2,  5,  2,  6,
    2,  7,  2,  8,  3,  1,  3,  2,  3,  3,  3,  4,  3,  5,  3,  6,
    3,  7,  4,  1,  4,  2,  4,  3,  4,  4,  4,  5,  5,  1,  5,  2,
    5,  3,  5,  4,  5,  5,  6,  1,  6,  2,  6,  3,  6,  4,  7,  1,
    7,  2,  7,  3,  7,  4,  8,  1,  8,  2,  8,  3,  9,  1,  9,  2,
    9,  3, 10,  1, 10,  2, 10,  3, 11,  1, 11,  2, 11,  3, 12,  1,
   12,  2, 13,  1, 13,  2, 14,  1, 14,  2, 15,  1, 15,  2, 16,  1,
   16,  2, 17,  1, 18,  1, 19,  1, 20,  1, 21,  1, 22,  1, 23,  1,
   24,  1, 25,  1, 26,  1,

    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  1,  1,  1,  2,  1,  3,  1,  4,  1,  5,  2,  1,  2,  2,
    2,  3,  2,  4,  3,  1,  3,  2,  3,  3,  3,  4,  4,  1,  4,  2,
    4,  3,  5,  1,  5,  2,  5,  3,  6,  1,  6,  2,  6,  3,  7,  1,
    7,  2,  8,  1,  8,  2,  9,  1,  9,  2, 10,  1, 10,  2, 11,  1,
   11,  2, 12,  1, 12,  2, 13,  1, 13,  2, 14,  1, 14,  2, 15,  1,
   16,  1, 17,  1, 18,  1, 19,  1, 20,  1, 21,  1, 22,  1, 23,  1,
   24,  1, 25,  1, 26,  1, 27,  1, 28,  1, 29,  1, 30,  1, 31,  1,
   32,  1, 33,  1, 34,  1, 35,  1, 36,  1,

/* delta level values */
   23, 11,  8,  7,  5,  5,  4,  4,  3,  3,  3,  3,  2,  2,  2,  2,
    2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,

    9,  5,  4,  4,  3,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  1,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
    1,  1,  1,  1,  1,

/* delta run values */
   26+1, 16+1, 11+1,  7+1,  5+1,  3+1,  3+1,  2+1,  1+1,  1+1,  1+1,
    0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,
    0+1,

   36+1, 14+1,  6+1,  3+1,  1+1,  0+1,  0+1,  0+1,  0+1
},

                VC1_CHROMA_RUN_LEVEL1_TAB[] =
{
   58,   /* StartIndexOfLast */
   94-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
  121-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  162-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  174-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  177,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  1,  1,  1,  2,  1,  3,  1,  4,
    1,  5,  1,  6,  2,  1,  2,  2,  2,  3,  2,  4,  3,  1,  3,  2,
    3,  3,  4,  1,  4,  2,  4,  3,  5,  1,  5,  2,  5,  3,  6,  1,
    6,  2,  6,  3,  7,  1,  7,  2,  8,  1,  8,  2,  9,  1,  9,  2,
   10,  1, 10,  2, 11,  1, 12,  1, 13,  1, 14,  1, 15,  1, 16,  1,
   17,  1, 18,  1, 19,  1, 20,  1, 21,  1, 22,  1, 23,  1, 24,  1,
   25,  1, 26,  1,

    0,  1,  0,  2,  0,  3,  1,  1,  1,  2,  2,  1,  3,  1,  4,  1,
    5,  1,  6,  1,  7,  1,  8,  1,  9,  1, 10,  1, 11,  1, 12,  1,
   13,  1, 14,  1, 15,  1, 16,  1, 17,  1, 18,  1, 19,  1, 20,  1,
   21,  1, 22,  1, 23,  1, 24,  1, 25,  1, 26,  1, 27,  1, 28,  1,
   29,  1, 30,  1, 31,  1, 32,  1, 33,  1, 34,  1, 35,  1, 36,  1,
   37,  1, 38,  1, 39,  1, 40,  1,

/* delta level values */
   12,  6,  4,  3,  3,  3,  3,  2,  2,  2,  2,  1,  1,  1,  1,  1,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,

    3,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
    1,  1,  1,  1,  1,  1,  1,  1,  1,

/* delta run values */
   26+1, 10+1,  6+1,  2+1,  1+1,  1+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,

   40+1,  1+1,  0+1
},

                VC1_CHROMA_RUN_LEVEL2_TAB[] =
{
  109,   /* StartIndexOfLast */
  136-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
  161-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  192-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  224-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  228,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  0, 13,  0, 14,  0, 15,  0, 16,
    0, 17,  0, 18,  0, 19,  0, 20,  0, 21,  0, 22,  0, 23,  0, 24,
    0, 25,  0, 26,  0, 27,  0, 28,  0, 29,  0, 30,  0, 31,  0, 32,
    1,  1,  1,  2,  1,  3,  1,  4,  1,  5,  1,  6,  1,  7,  1,  8,
    1,  9,  1, 10,  1, 11,  1, 12,  1, 13,  2,  1,  2,  2,  2,  3,
    2,  4,  2,  5,  2,  6,  2,  7,  2,  8,  3,  1,  3,  2,  3,  3,
    3,  4,  3,  5,  3,  6,  4,  1,  4,  2,  4,  3,  4,  4,  4,  5,
    5,  1,  5,  2,  5,  3,  5,  4,  6,  1,  6,  2,  6,  3,  6,  4,
    7,  1,  7,  2,  7,  3,  8,  1,  8,  2,  8,  3,  9,  1,  9,  2,
    9,  3, 10,  1, 10,  2, 11,  1, 11,  2, 12,  1, 12,  2, 13,  1,
   13,  2, 14,  1, 14,  2, 15,  1, 15,  2, 16,  1, 16,  2, 17,  1,
   17,  2, 18,  1, 18,  2, 19,  1, 19,  2, 20,  1, 20,  2, 21,  1,
   21,  2, 22,  1, 22,  2, 23,  1, 24,  1,

    0,  1,  0,  2,  0,  3,  0,  4,  1,  1,  1,  2,  1,  3,  2,  1,
    2,  2,  2,  3,  3,  1,  3,  2,  3,  3,  4,  1,  4,  2,  5,  1,
    5,  2,  6,  1,  6,  2,  7,  1,  7,  2,  8,  1,  8,  2,  9,  1,
    9,  2, 10,  1, 10,  2, 11,  1, 11,  2, 12,  1, 12,  2, 13,  1,
   13,  2, 14,  1, 14,  2, 15,  1, 15,  2, 16,  1, 16,  2, 17,  1,
   17,  2, 18,  1, 18,  2, 19,  1, 19,  2, 20,  1, 20,  2, 21,  1,
   21,  2, 22,  1, 22,  2, 23,  1, 23,  2, 24,  1, 24,  2, 25,  1,
   25,  2, 26,  1, 26,  2, 27,  1, 27,  2, 28,  1, 28,  2, 29,  1,
   30,  1,

/* delta level values */
   32, 13,  8,  6,  5,  4,  4,  3,  3,  3,  2,  2,  2,  2,  2,  2,
    2,  2,  2,  2,  2,  2,  2,  1,  1,

    4,  3,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
    2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  1,  1,

/* delta run values */
   24+1, 22+1,  9+1,  6+1,  4+1,  3+1,  2+1,  2+1,  1+1,  1+1,  1+1,
    1+1,  1+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,
    0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,  0+1,

   30+1,  28+1,  3+1,  0+1
},

                VC1_CHROMA_RUN_LEVEL3_TAB[] =
{
   81,   /* StartIndexOfLast */
  140-1, /* delta level (last=0) offset-(StartIndexOfLast*2) */
  170-2, /* delta level (last=1) offset-(StartIndexOfLast*2) */
  214-4, /* delta run   (last=0) offset-(StartIndexOfLast*2) */
  228-5, /* delta run   (last=1) offset-(StartIndexOfLast*2) */
  233,   /* total value count - (StartIndexOfLast*2) */

/* run/level pairs */
    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  0,  6,  0,  7,  0,  8,
    0,  9,  0, 10,  0, 11,  0, 12,  0, 13,  0, 14,  1,  1,  1,  2,
    1,  3,  1,  4,  1,  5,  1,  6,  1,  7,  1,  8,  1,  9,  2,  1,
    2,  2,  2,  3,  2,  4,  2,  5,  3,  1,  3,  2,  3,  3,  3,  4,
    4,  1,  4,  2,  4,  3,  4,  4,  5,  1,  5,  2,  5,  3,  5,  4,
    6,  1,  6,  2,  6,  3,  7,  1,  7,  2,  7,  3,  8,  1,  8,  2,
    8,  3,  9,  1,  9,  2,  9,  3, 10,  1, 10,  2, 10,  3, 11,  1,
   11,  2, 11,  3, 12,  1, 12,  2, 12,  3, 13,  1, 13,  2, 14,  1,
   14,  2, 15,  1, 15,  2, 16,  1, 17,  1, 18,  1, 19,  1, 20,  1,
   21,  1, 22,  1, 23,  1, 24,  1, 25,  1, 26,  1, 27,  1, 28,  1,
   29,  1,

    0,  1,  0,  2,  0,  3,  0,  4,  0,  5,  1,  1,  1,  2,  1,  3,
    1,  4,  2,  1,  2,  2,  2,  3,  3,  1,  3,  2,  3,  3,  4,  1,
    4,  2,  5,  1,  5,  2,  6,  1,  6,  2,  7,  1,  7,  2,  8,  1,
    8,  2,  9,  1,  9,  2, 10,  1, 10,  2, 11,  1, 11,  2, 12,  1,
   12,  2, 13,  1, 13,  2, 14,  1, 14,  2, 15,  1, 15,  2, 16,  1,
   17,  1, 18,  1, 19,  1, 20,  1, 21,  1, 22,  1, 23,  1, 24,  1,
   25,  1, 26,  1, 27,  1, 28,  1, 29,  1, 30,  1, 31,  1, 32,  1,
   33,  1, 34,  1, 35,  1, 36,  1, 37,  1, 38,  1, 39,  1, 40,  1,
   41,  1, 42,  1, 43,  1,

/* delta level values */
   14,  9,  5,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,

    5,  4,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,

/* delta run values */
   29+1, 15+1, 12+1,  5+1,  2+1,  1+1,  1+1,  1+1,  1+1,  0+1,  0+1,
    0+1,  0+1,  0+1,

   43+1, 15+1,  3+1,  1+1,  0+1
},

                VC1_ZIGZAG_INTRA_NORM[] =
{
    0,  8,  1,  2,  9, 16, 24, 17, 10,  3,  4, 11, 18, 25, 32, 40,
   33, 48, 26, 19, 12,  5,  6, 13, 20, 27, 34, 41, 56, 49, 57, 42,
   35, 28, 21, 14,  7, 15, 22, 29, 36, 43, 50, 58, 51, 59, 44, 37,
   30, 23, 31, 38, 45, 52, 60, 53, 61, 46, 39, 47, 54, 62, 55, 63
},

                VC1_ZIGZAG_INTRA_VERT[] =
{
    0,  8, 16,  1, 24, 32, 40,  9,  2,  3, 10, 17, 25, 48, 56, 41,
   33, 26, 18, 11,  4,  5, 12, 19, 27, 34, 49, 57, 50, 42, 35, 28,
   20, 13,  6,  7, 14, 21, 29, 36, 43, 51, 58, 59, 52, 44, 37, 30,
   22, 15, 23, 31, 38, 45, 60, 53, 46, 39, 47, 54, 61, 62, 55, 63
},

                VC1_ZIGZAG_INTRA_HORIZ[] =
{
    0,  1,  8,  2,  3,  9, 16, 24, 17, 10,  4,  5, 11, 18, 25, 32,
   40, 48, 33, 26, 19, 12,  6,  7, 13, 20, 27, 34, 41, 56, 49, 57,
   42, 35, 28, 21, 14, 15, 22, 29, 36, 43, 50, 58, 51, 44, 37, 30,
   23, 31, 38, 45, 52, 59, 60, 53, 46, 39, 47, 54, 61, 62, 55, 63
},

                VC1_ZIGZAG_INTER_8x8[] =
{
    0,  8,  1,  2,  9, 16, 24, 17, 10,  3,  4, 11, 18, 25, 32, 40,
   48, 56, 41, 33, 26, 19, 12,  5,  6, 13, 20, 27, 34, 49, 57, 58,
   50, 42, 35, 28, 21, 14,  7, 15, 22, 29, 36, 43, 51, 59, 60, 52,
   44, 37, 30, 23, 31, 38, 45, 53, 61, 62, 54, 46, 39, 47, 55, 63,
  255
},

                VC1_ZIGZAG_INTER_8x4[] =
{
    0,     1,     2,     8,     3,     9,    10,    16,
    4,    11,    17,    24,    18,    12,     5,    19,
   25,    13,    20,    26,    27,     6,    21,    28,
   14,    22,    29,     7,    30,    15,    23,    31,
  128,
    0+32,  1+32,  2+32,  8+32,  3+32,  9+32, 10+32, 16+32,
    4+32, 11+32, 17+32, 24+32, 18+32, 12+32,  5+32, 19+32,
   25+32, 13+32, 20+32, 26+32, 27+32,  6+32, 21+32, 28+32,
   14+32, 22+32, 29+32,  7+32, 30+32, 15+32, 23+32, 31+32,
  255
},

                VC1_ZIGZAG_INTER_4x8[] =
{
    0,     4+ 4,  1,     8+ 8,  5+ 4, 12+12,  9+ 8,  2,
   16+16,  6+ 4, 13+12, 20+20, 10+ 8, 24+24, 17+16, 14+12,
   28+28, 21+20, 18+16,  3,    25+24, 29+28,  7+ 4, 22+20,
   11+ 8, 26+24, 15+12, 30+28, 19+16, 23+20, 27+24, 31+28,
  128,
    0+ 4,  4+ 8,  1+ 4,  8+12,  5+ 8, 12+16,  9+12,  2+ 4,
   16+20,  6+ 8, 13+16, 20+24, 10+12, 24+28, 17+20, 14+16,
   28+32, 21+24, 18+20,  3+ 4, 25+28, 29+32,  7+ 8, 22+24,
   11+12, 26+28, 15+16, 30+32, 19+20, 23+24, 27+28, 31+32,
  255
},

                VC1_ZIGZAG_INTER_4x4[] =
{
    0,     4+ 4,  8+ 8,  1,     5+ 4, 12+12,  9+ 8,  2,
    6+ 4, 10+ 8, 13+12,  3,     7+ 4, 14+12, 11+ 8, 15+12,
  128,
    0+ 4,  4+ 8,  8+12,  1+ 4,  5+ 8, 12+16,  9+12,  2+ 4,
    6+ 8, 10+12, 13+16,  3+ 4,  7+ 8, 14+16, 11+12, 15+16,
  128,
    0+32,  4+36,  8+40,  1+32,  5+36, 12+44,  9+40,  2+32,
    6+36, 10+40, 13+44,  3+32,  7+36, 14+44, 11+40, 15+44,
  128,
    0+36,  4+40,  8+44,  1+36,  5+40, 12+48,  9+44,  2+36,
    6+40, 10+44, 13+48,  3+36,  7+40, 14+48, 11+44, 15+48,
  255
};
/*
static const u8 VC1_ZIGZAG_INTRA_NONE[] =
{
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
   16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
   32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
   48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
};
*/


const u8 *VC1_RUN_LEVEL_TAB[] = {VC1_LUMA_RUN_LEVEL0_TAB,
                                 VC1_LUMA_RUN_LEVEL1_TAB,
                                 VC1_LUMA_RUN_LEVEL2_TAB,
                                 VC1_LUMA_RUN_LEVEL3_TAB,
                                 VC1_CHROMA_RUN_LEVEL0_TAB,
                                 VC1_CHROMA_RUN_LEVEL1_TAB,
                                 VC1_CHROMA_RUN_LEVEL2_TAB,
                                 VC1_CHROMA_RUN_LEVEL3_TAB},
         *VC1_ZIGZAG_TAB[]    = {/*VC1_ZIGZAG_INTRA_NONE+1,
                                 VC1_ZIGZAG_INTRA_NONE+1,
                                 VC1_ZIGZAG_INTRA_NONE+1,
                                 VC1_ZIGZAG_INTRA_NONE+1,*/
                                 VC1_ZIGZAG_INTRA_NORM+1,
                                 VC1_ZIGZAG_INTRA_VERT+1,
                                 VC1_ZIGZAG_INTRA_NORM+1,
                                 VC1_ZIGZAG_INTRA_HORIZ+1,
                                 VC1_ZIGZAG_INTER_8x8,
                                 VC1_ZIGZAG_INTER_8x4,
                                 VC1_ZIGZAG_INTER_4x8,
                                 VC1_ZIGZAG_INTER_4x4};

